﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Browser;
using System.Windows.Controls.Primitives;

namespace DialogDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void bnDialog1_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("This is a MessageBox dialog.", "MessageBox", MessageBoxButton.OK);
        }

        private void bnDialog2_Click(object sender, RoutedEventArgs e)
        {
            HtmlPage.Window.Alert("This is a Alert dialog");
        }

        private void bnDialog3_Click(object sender, RoutedEventArgs e)
        {
            Popup popup = new Popup();
            Border border = this.CreateMessageBox("This is a Popup dialog.", (m, n) => popup.IsOpen = false);
            popup.Child = border;
            popup.HorizontalOffset = (this.ActualWidth - border.Width) / 2;
            popup.VerticalOffset = (this.ActualHeight - border.Height) / 2;
            popup.IsOpen = true;
        }

        private void bnDialog4_Click(object sender, RoutedEventArgs e)
        {
            ChildWindow1 cw = new ChildWindow1();
            cw.Show();
        }

        private void bnDialog5_Click(object sender, RoutedEventArgs e)
        {
            UIElement elem = this.LayoutRoot.Children.FirstOrDefault((m) => m is Border);
            if (elem == null)
            {
                Border border = null;
                border = this.CreateMessageBox("This is a Custom dialog.", (m, n) =>
                    {
                        border.Visibility = Visibility.Collapsed;
                    });
                Grid.SetRow(border, 2);
                Grid.SetColumn(border, 0);
                Grid.SetColumnSpan(border, 3);
                this.LayoutRoot.Children.Add(border);
                elem = border;
            }
            elem.Visibility = Visibility.Visible;
        }

        private Border CreateMessageBox(string message, RoutedEventHandler clickHandler)
        {
            Border border = new Border();
            border.Width = 175;
            border.Height = 120;
            border.CornerRadius = new CornerRadius(5);
            border.BorderThickness = new Thickness(1.5);
            border.BorderBrush = new SolidColorBrush(Colors.DarkGray);
            border.Background = new SolidColorBrush(Colors.LightGray);

            Grid grid = new Grid();
            grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(60) });
            grid.RowDefinitions.Add(new RowDefinition() { Height = new GridLength(60) });

            TextBlock tb = new TextBlock()
            {
                Text = message,
                VerticalAlignment = VerticalAlignment.Center,
                HorizontalAlignment = HorizontalAlignment.Center
            };
            Grid.SetRow(tb, 0);
            grid.Children.Add(tb);

            Button bn = new Button()
            {
                Content = "OK",
                Width = 75,
                Height = 25,
                HorizontalAlignment = HorizontalAlignment.Center,
                VerticalAlignment = VerticalAlignment.Center
            };
            Grid.SetRow(bn, 1);
            bn.Click += clickHandler;
            grid.Children.Add(bn);

            border.Child = grid;

            return border;
        }
    }
}
